Bug 267021

Summary: g-v-m cannot mount read-only crypted volumes
Product: [Fedora] Fedora Reporter: Tim Niemueller <tim>
Component: gnome-volume-managerAssignee: David Zeuthen <davidz>
Status: CLOSED WONTFIX QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: low Docs Contact:
Priority: medium    
Version: 9CC: mclasen, triage
Target Milestone: ---   
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2009-07-14 10:05:00 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:

Description Tim Niemueller 2007-08-30 09:44:19 EDT
Description of problem:
If an encrypted volume is added, for example a DVD which has been encrypted
using http://gentoo-wiki.com/HOWTO_Burn_Encrypted_Optical_Media_With_Luks, the
volume is correctly recognized as encrypted. However, when g-v-m tries to mount
the volume it seems that it does not pass the --readonly flag to cryptsetup (as
I can trigger the same problem on the command line if that flag is missing).

In this case cryptsetup fails with the following error in dmesg:
device-mapper: table: 253:4: crypt: Device lookup failed
device-mapper: ioctl: error adding target to table
device-mapper: ioctl: device doesn't appear to be in the dev hash table.

Version-Release number of selected component (if applicable):
gnome-volume-manager-2.17.0-7.fc7

How reproducible:
Always

Steps to Reproduce:
1. Create read-only encrypted volume like an encrypted DVD
2. Add the encrypted volume to the system
3. Enter the password and see the mounting fail
  
Actual results:
Volume is not mounted.

Expected results:
Volume should be mounted.

Additional info:
The DVD can be mounted and basically everything is there. All g-v-m has to do is
to check if it'S accessing a read-only volume and in that case pass the
--readonly flag to cryptsetup.
Comment 1 Tim Niemueller 2007-10-10 18:04:23 EDT
I have played with it a bit and what I came up with is the following:
I modified /usr/lib64/hal/scripts/linux/hal-luks-setup-linux like the following:

--- orig.hal-luks-setup-linux   2007-10-10 23:47:25.000000000 +0200
+++ hal-luks-setup-linux        2007-10-10 23:53:53.000000000 +0200
@@ -22,7 +22,13 @@
     exit 1
 fi
 
-if ! echo "$PASSWORD" | $CRYPTSETUP luksOpen $HAL_PROP_BLOCK_DEVICE
luks_crypto_$HAL_PROP_VOLUME_UUID  2> /dev/null; then
+READONLY=
+if [ "$HAL_PROP_VOLUME_IS_DISC" = "true" ]; then
+       # assume read-only for discs
+       READONLY="--readonly"
+fi
+
+if ! echo "$PASSWORD" | $CRYPTSETUP $READONLY luksOpen $HAL_PROP_BLOCK_DEVICE
luks_crypto_$HAL_PROP_VOLUME_UUID  2> /dev/null; then
     echo org.freedesktop.Hal.Device.Volume.Crypto.SetupPasswordError >&2
     echo Error setting up $HAL_PROP_BLOCK_DEVICE - bad password? >&2
     exit 1

This makes the cryptsetup call succeed. The device file is there and the
/dev/dm-? entry is created, but the decrypted volume does not appear in the
hal-device manager as it does for regular crypto hard drives. No mount point is
created in /media and it's not mounted.

If you could give some input for further investigation where this could hang
that would really be appreciated as I really want to get this working.
Comment 2 Tim Niemueller 2008-04-04 10:00:43 EDT
David, did you have the time to look at this or will it still be borked on F-9?
Comment 3 Bug Zapper 2008-05-14 10:10:10 EDT
This message is a reminder that Fedora 7 is nearing the end of life. Approximately 30 (thirty) days from now Fedora will stop maintaining and issuing updates for Fedora 7. It is Fedora's policy to close all bug reports from releases that are no longer maintained. At that time this bug will be closed as WONTFIX if it remains open with a Fedora 'version' of '7'.

Package Maintainer: If you wish for this bug to remain open because you plan to fix it in a currently maintained version, simply change the 'version' to a later Fedora version prior to Fedora 7's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that we may not be able to fix it before Fedora 7 is end of life. If you would still like to see this bug fixed and are able to reproduce it against a later version of Fedora please change the 'version' of this bug. If you are unable to change the version, please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's lifetime, sometimes those efforts are overtaken by events. Often a more recent Fedora release includes newer upstream software that fixes bugs or makes them obsolete. If possible, it is recommended that you try the newest available Fedora distribution to see if your bug still exists.

Please read the Release Notes for the newest Fedora distribution to make sure it will meet your needs:
http://docs.fedoraproject.org/release-notes/

The process we are following is described here: http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 4 Tim Niemueller 2008-05-14 19:12:39 EDT
This problem still persists on F-9. David, do you have comments on what would be
the right way to fix this. With that input I could have a look myself.
Comment 5 Tim Niemueller 2008-08-12 03:30:20 EDT
David, is this going to be fixed for F-10?
Comment 6 Bug Zapper 2009-06-09 18:48:15 EDT
This message is a reminder that Fedora 9 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 9.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '9'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 9's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 9 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 7 Bug Zapper 2009-07-14 10:05:00 EDT
Fedora 9 changed to end-of-life (EOL) status on 2009-07-10. Fedora 9 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.